class CRange {
 public:
    double inf, sup;

    CRange();
    CRange( double infin, double supin );

    void set_from_string( const string& text );

    bool finite() const;
    bool contained(double val) const;
    double value2plotcoord( int logflag, double v ) const;
    double plotcoord2value( int logflag, double c ) const;
    double inf_pos(void) const;

    void Round(int logflag, double relmargin, double digits);

    string str(void) const;
};


class CAxis {
 public:
    CRange R, AlternateR;
    CCoord C;
    bool   log;
    bool   force;

    inline CAxis() { R=CRange(); };

    void Ask( const string& quest );
    void SetLog( const bool _log );

    double pc(double v) const;
};


namespace NPlot { // additional declarations in dualplot.cpp
    extern class CAxis X, Y;
    extern uint maxpoints;

    void Multiask();

    void Open();
    void Close();

    void Clear();
    void Box();
    void Line( const bool as_line, const int style_no,
               const vector<double> x, const vector<double> y,
               const vector<double>* z,
               const string xco, const string yco,
               const string info );
    void Doc (vector<string> lDoc);
    void Save( bool full_outfile );
    void Dialog();
};
