#include <stdlib.h>
#include <math.h>
#include <fftw3.h>
#include <iostream>
#include <string>
#include <vector>

using namespace std;

#include "olm.h"
#include "asi.h"
#include "special.h"

namespace NSpecial {
    void q_eval( double *par, int m_dat, double *fvec, void *data, int *info);
    void lm_print(int n_par, double *par, int m_dat, double *fvec,
                  void *data, int iflag, int iter, int nfev);
    double q_kernel( double t, double *p );
}

void NSpecial::FourierCosine(void) 
{
	NOlm::IterateD fiter;
	NOlm::SelNew();

	COld *fin, fout;
	CScan *Sin, Sout;

        fftw_plan plan;
        int n, nold=-1;

	while((fin=fiter())) {
		fout = *fin;
		fout.lDoc.push_back("delete points ...");
		fout.VS.clear();

                // *** set coordinates ***
//                olf.xco = CCoord("z", "m");
//                olf.yco = CCoord("B_dim", "B-unit");

		for (uint j=0; j<fin->VS.size(); j++) {
			Sin = &(fin->VS[j]);
			Sout = *Sin;
//			Sout.x.clear();
                        n = Sin->size();
			// Sout.y.resize(n);
                        
                        plan = fftw_plan_r2r_1d(
                                n, &(Sin->y[0]), &(Sout.y[0]),
                                FFTW_REDFT00,  FFTW_ESTIMATE);
                        nold = n; // currently not used
                        fftw_execute( plan );

                        for ( uint i=0; i<n; ++i ) {
                                Sout.y[i] /= sqrt(2.*n);
                        }

			if (Sout.size())
				fout.VS.push_back(Sout);
		}
		if (fout.VS.size())
			NOlm::OloAdd(&fout);
		else 
			cout << "no data point left\n";
	}
}
